
PROGRAM wetland;

{Wetland and clonal plant simulation program


 Copyright 1987, 1988 by Aaron M. Ellison.

 Random number generators are licensed portions of TURBO_RAND
  Copyright 1986 Loesl, Ltd., Pennellville, NY 13132

 Developed in collaboration with Dr. Barbara Bedford, Ecosystems Research
  Center, Cornell University, Ithaca, New York, 14853.

 DEVELOPER IS NOT RESPONSIBLE FOR PROGRAM IF SOURCE CODE IS ALTERED IN ANY WAY}


{Global Variable Definitions}

CONST
    max = 50; maxyr = 3; maxsp = 10; maxchar = 13;
TYPE
    yearfield=array[1..max,1..max,1..4] of byte;
    standardfield=array[1..maxyr] of yearfield;
    speciesid=array[1..maxchar] of string[2];
    speciesdef=array[1..maxsp] of speciesid;
    tagdef = string[6];
    bankcell = record specbank : array[1..10] of integer; end;

VAR
    topyr,nspecies,i,j,k,l,m,n,xcoord,ycoord,filestatus,offadd,segadd : integer;
    serr,specno,month,year,growseason,tempval,testlet,retcode : integer;
    startflood,topyear,chngnum,chngchar,runtime : integer;
    xstart,ystart : array[1..maxsp] of byte;
    flood : array[1..max,1..max,1..2] of byte;
    universe : standardfield;
    species : speciesdef;
    yesno : char;
    initfile, newfile: text;
    filename, newname : string[12];
    compugo,temp : string[1];
    go : char;
    settag : tagdef;
    xycell,heaptop : ^bankcell;
    empty, ranseed : real;

PROCEDURE exitprog {exits program};
  BEGIN; {exit}
   writeln('====>Exiting program...bye');
  END;

{PROCEDURE writeout; writes field to screen

VAR i,j,k : integer;
    BEGIN
      for i := 1 to maxyr do
      BEGIN
       for l := 1 to 4 do
       BEGIN  for k := 1 to max do
           BEGIN  for j := 1 to max do
              write(universe[i,j,k,l]);
              writeln;
           END;
         writeln;
         writeln;
       END;
     writeln;
     writeln ('end of seasons');
    END;
   writeln;
   writeln;
   END;
}

PROCEDURE printout; {writes to printer}
 VAR outmatrix : array[1..50,1..50] of string[1];
     seastag : string[6];
     rowmark : byte;
     dummy : array[1..11] of real;
     bare_mud,flooded : real;

 LABEL DUMB;

 BEGIN {printout}
 FOR j := 1 to 11 DO dummy[j] :=0.0;
{ CASE month OF
   1 : seastag := 'Spring';
   2 : seastag := 'Summer';
   3 : seastag := 'Fall';
   4 : seastag := 'Winter';
  END;}
{ for j := 1 to max do
   BEGIN for k := 1 to max do
    CASE universe[year,j,k,month] OF
    0 : outmatrix[j,k] := ' ';
    1 : outmatrix[j,k] := 'A';
    2 : outmatrix[j,k] := 'B';
    3 : outmatrix[j,k] := 'C';
    4 : outmatrix[j,k] := 'D';
    5 : outmatrix[j,k] := 'E';
    6 : outmatrix[j,k] := 'F';
    7 : outmatrix[j,k] := 'G';
    8 : outmatrix[j,k] := 'H';
    9 : outmatrix[j,k] := 'J';
   10 : outmatrix[j,k] := 'K';
   END;
  END;}
 write(lst,year+((runtime-1)*3):4,month:2);
{ rowmark := 1;
  DUMB:
   for k := 1 to max do
    write(lst,outmatrix[rowmark,k]);
    writeln(lst);
   rowmark := rowmark+1;
   if rowmark < 51 then GOTO DUMB;
  writeln(lst);}
 FOR j := 1 to max DO BEGIN
  FOR k := 1 to max DO BEGIN
   IF universe[year,j,k,month]>0 THEN BEGIN
    specno := universe[year,j,k,month];
    dummy[specno] := dummy[specno]+1;
   END
   ELSE dummy[11] := dummy[11]+1;
  END;
 END;
 empty := 0.0;
 FOR j := 1 to 11 DO BEGIN
  dummy[j] := (dummy[j]/2500)*100;
 END;
 FOR j := 1 to 11 DO BEGIN
  write(lst,dummy[j]:5:2);
 END;
 bare_mud := 0.0;
 flooded := 0.0;
 FOR j := 1 to 50 DO BEGIN
  FOR k := 1 to 50 DO BEGIN
   IF flood[j,k,((month-1) mod 2) +1] < 10 THEN
    bare_mud := bare_mud+1
   ELSE
    flooded := flooded+1;
  END;
 END;
 write(lst,(bare_mud/2500)*100:5:2);
 write(lst,(flooded/2500)*100:5:2);
 writeln(lst);
END {printout};

{$C-}

{The following included files contain necessary subroutines, etc.}

{$I typedecl.tr}
{$I empty87.tr}
{$I setarrsp.tr}
{$I arnirswo.tr}
{$I wetset }
{$I wetutil }
{$I wetseed }
{$I wetgrow }

{DRIVER}

BEGIN
ClrScr;                                               {Date completed}
introduce;  {Display header}                          {09 December 1986}
initialize; {Set all universe boxes to 0}             {01 December 1986}
wetset;     {Get species definitions from user}       {08 December 1986}
seed;       {Seed the wetland with species}           {16 February 1987}
growdriv;   {grow the wetland}                        {03 May      1987}
writeln ('done');

END.
