
{Setup procedure for program WETLAND. Contains the following procedures:
 WETSET, YOUSET, ISET, DEFINESPECIES, SPECDEFCHECK, SHOWSPECIES,
 SHOWCHARS, GETNAME}

{Copyright 1987 by Aaron M. Ellison}

{DEBUGGED AND RUNNING 05-DEC-1986}
{AMENDED 09-DEC-1986}

OVERLAY PROCEDURE getname (var filestatus : integer);
         {read a filename from the console and open for input}
VAR eoname : integer;
LABEL GOFILE;
   BEGIN {getname}
      writeln;
     GOFILE: write(' Enter name of species definition file ===> ');
      readln(filename);
      for i := 1 to length(filename) do filename[i] := upcase(filename[i]);
      if length(filename)>0 then BEGIN
       if pos('.',filename)=0 then BEGIN
         eoname := pos(' ',filename)-1;
         if eoname > -1 then filename := copy(filename,1,eoname) + '.DAT'
          else filename := filename + '.DAT';
          assign(initfile,filename);
         END;
       writeln('This run will use the definition file ===> ',filename);
       REPEAT
       write('Is this a new file (y/n): ');
        readln(yesno);
         if upcase(yesno) = 'Y' then filestatus := 1
         else if upcase(yesno) = 'N' then filestatus := 0
       UNTIL upcase(yesno) IN ['Y','N'];
      END
    else goto GOFILE;
   END;



OVERLAY PROCEDURE showspecies {displays all species definitions};
BEGIN
       writeln;
       writeln(' ':23, 'Character #');
writeln(' ':7,'------------------------------------------------------');
writeln('Sp. #','1':6,'2':4,'3':4,'4':4,'5':4,'6':4,'7':4,'8':4,'9':4,'10':4,
        '11':4,'12':4,'13':4);
writeln('-------------------------------------------------------------');
 BEGIN for i:= 1 to nspecies do
  writeln('|',i:3,'|':3,
         species[i,1]:5,species[i,2]:4,species[i,3]:4,species[i,4]:4,
         species[i,5]:4,species[i,6]:4,species[i,7]:4,species[i,8]:4,
         species[i,9]:4,species[i,10]:4,species[i,11]:4,species[i,12]:4,
         species[i,13]:4,' |');
 END;
writeln('-------------------------------------------------------------');
writeln;
END;



OVERLAY PROCEDURE showchars(var m: integer) {displays definitions of a single species};
BEGIN
       writeln;
       writeln(' ':23, 'Character #');
writeln(' ':7,'------------------------------------------------------');
writeln('Sp. #','1':6,'2':4,'3':4,'4':4,'5':4,'6':4,'7':4,'8':4,'9':4,'10':4,
        '11':4,'12':4,'13':4);
writeln('-------------------------------------------------------------');
 writeln('|',m:3,'|':3,
         species[m,1]:5,species[m,2]:4,species[m,3]:4,species[m,4]:4,
         species[m,5]:4,species[m,6]:4,species[m,7]:4,species[m,8]:4,
         species[m,9]:4,species[m,10]:4,species[m,11]:4,species[m,12]:4,
         species[m,13]:4,' |');
writeln('-------------------------------------------------------------');
writeln;
END;



PROCEDURE specdefcheck {checks species definitions and enables changes};
VAR
 cyesno, syesno, pyesno : string[1];
 newchar : string[1];
 tempid : speciesid;
BEGIN {specdefcheck}
       writeln('The species definitions that will be used are:');
       writeln;
       writeln('Using file: ',filename);
       showspecies;
  BEGIN
   REPEAT
   write('Would you like to change any of these character definitions (y/n): ');
     readln(yesno);
   UNTIL upcase(yesno) IN ['Y','N'];
       if upcase(yesno) = 'Y' then BEGIN {change character routine}
        syesno := 'Y';
        WHILE syesno = 'Y' do BEGIN
         cyesno := 'Y';
         REPEAT
          write('Which species number ===> ');
           readln(chngnum);
         UNTIL chngnum IN [1..nspecies];
         m := chngnum;
       writeln;
       writeln('The character definitions for species ',m,' are:');
         showchars(m);
        WHILE cyesno = 'Y' do BEGIN
         REPEAT
          write('Which character number ===> ');
            readln(chngchar);
         UNTIL chngchar IN [1..maxchar];
          if chngchar = 1 then BEGIN
           for j := 1 to maxchar do
            tempid[j] := species[chngnum,j];
           END;
         writeln('The current definition is ',species[chngnum,chngchar]);
         writeln('The possible definitions of this character are');
         writeln;
         CASE chngchar OF
          1: writeln('Annual or Perennial');
          2: writeln('Rhizomatous, Bulbous, or Tuberous');
          3: writeln('Guerrilla or Phalanx');
          4: writeln('Fast or Slow growth rate');
          5: writeln('Spring, (E)summer, Fall, Winter, or Continuous growth');
          6: writeln('mean duration of connection [1 =< mean =< 36]');
          7: writeln('S.D. duration of connection [0 =< S.D. =< 36]');
          8: writeln('Far or Near seed dispersal');
          9: writeln('1, 2, or 3 years in seed bank');
         10: writeln('germinate during Drawdown, Underwater, or Both');
         11: writeln('competition permitted (y/n)');
         12: writeln('competitive rank [1 <= rank =< ',nspecies);
         13: writeln('competitive networks permitted (y/n)');
         END;
         writeln;
         if (chngchar in [6,7]) then BEGIN
           REPEAT
           write('Enter new definition ===> ');
           readln(species[chngnum,chngchar]);
            val(species[chngnum,chngchar],tempval,retcode);
           UNTIL tempval IN [0..36];
           END
          else BEGIN
           CASE chngchar OF
            1: BEGIN
               REPEAT
                write('Enter new definition ===> ');
                readln(newchar);
               UNTIL upcase(newchar) IN ['A','P'];
              END;
            2:BEGIN
               REPEAT
                write('Enter new definition ===> ');
                readln(newchar);
               UNTIL upcase(newchar) IN ['R','B','T'];
              END;
            3:BEGIN
               REPEAT
                write('Enter new definition ===> ');
                readln(newchar);
               UNTIL upcase(newchar) IN ['G','P'];
              END;
            4:BEGIN
               REPEAT
                write('Enter new definition ===> ');
                readln(newchar);
               UNTIL upcase(newchar) IN ['F','S'];
              END;
            5:BEGIN
               REPEAT
                write('Enter new definition ===> ');
                readln(newchar);
               UNTIL upcase(newchar) IN ['S','E','F','W','C'];
              END;
            8:BEGIN
               REPEAT
                write('Enter new definition ===> ');
                readln(newchar);
               UNTIL upcase(newchar) IN ['F','N'];
              END;
            9:BEGIN
               REPEAT
                write('Enter new definition ===> ');
                readln(newchar);
                val(newchar,tempval,retcode);
               UNTIL tempval IN [1..3];
              END;
           10:BEGIN
               REPEAT
                write('Enter new definition ===> ');
                readln(newchar);
               UNTIL upcase(newchar) IN ['D','U','B'];
              END;
           11:BEGIN
               REPEAT
                write('Enter new definition ===> ');
                readln(newchar);
               UNTIL upcase(newchar) IN ['Y','N'];
              END;
           12:BEGIN
               REPEAT
                write('Enter new definition ===> ');
                readln(newchar);
                val(newchar,tempval,retcode);
               UNTIL tempval IN [1..nspecies];
              END;
           13:BEGIN
               REPEAT
                write('Enter new definition ===> ');
                readln(newchar);
               UNTIL upcase(newchar) IN ['Y','N'];
            END;
              END;
             species[chngnum,chngchar] := newchar;
          END;
         if not (chngchar in [6,7]) then
           species[chngnum,chngchar] := upcase(species[chngnum,chngchar]);
           {$R-}
            val(species[chngnum,chngchar],testlet,retcode);
            if retcode <>0 then
            species[chngnum,chngchar] := species[chngnum,chngchar] + ' ';
            if (retcode = 0) and (testlet < 10) then
            species[chngnum,chngchar] := '0' + species[chngnum,chngchar];
           {$R+}
             if chngchar = 1 then BEGIN
              {change other chars associated with annual/perennial tag}
              if (tempid[1]='P ') and (species[chngnum,1]='A ') then
                BEGIN {perennial ===> annual changes}
                 species[chngnum,2] := '  ';
                 species[chngnum,3] := '  ';
                 species[chngnum,4] := '  ';
                 species[chngnum,6] := '00';
                 species[chngnum,7] := '00';
                END
              else if (tempid[1]='A ') and (species[chngnum,1]='P ') then
                BEGIN {annual ===> perennial changes}
                 write('Rhizomatous, Bulbous, or Tuberous: ');
                 readln(temp);
                 species[chngnum,2] := upcase(temp) + ' ';
                 write('Guerrilla or Phalanx morphology: ');
                 readln(temp);
                 species[chngnum,3] := upcase(temp) + ' ';
                 write('Fast or Slow growing: ');
                 readln(temp);
                 species[chngnum,4] := upcase(temp) + ' ';
                 writeln('Mean duration of connection persistence in months');
                 write('[1 =< mean =< 36]: ');
                 readln(species[chngnum,6]);
                  val(species[chngnum,6],tempval,retcode);
                   if tempval < 10 then
                   species[chngnum,6] := '0' + species[chngnum,6];
                 writeln('S.D. duration of connection persistence in months');
                 write('[0 =< S.D. =< 36]: ');
                 readln(species[chngnum,7]);
                  val(species[chngnum,7],tempval,retcode);
                   if tempval < 10 then
                   species[chngnum,7] := '0' + species[chngnum,7];
                END;
             END;
          writeln('The new definitions for species ',m,' are:');
          showchars(m);
           REPEAT
            write('Any more changes to this species (y/n): ');
            readln(cyesno);
            cyesno := upcase(cyesno);
           UNTIL upcase(cyesno) IN ['Y','N'];
         END;
         writeln('The new definitions for all of the species are:');
         showspecies;
          REPEAT
           write('Any more changes to any species (y/n): ');
           readln(syesno);
           syesno := upcase(syesno);
          UNTIL upcase(syesno) IN ['Y','N'];
        END;
       if filestatus = 0 then BEGIN
        REPEAT
         write
         ('Do you want to permanently save the new species definitions (y/n): ');
           readln(pyesno);
           pyesno := upcase(pyesno);
        UNTIL upcase(pyesno) IN ['Y','N'];
         if pyesno = 'Y' then BEGIN
          REPEAT
          write('Enter new filename ===> ');
          readln(newname);
          UNTIL length(newname) > 0;
           for i := 1 to length(newname) do
            newname[i] := upcase(newname[i]);
           if pos('.',newname)=0 then newname := newname + '.DAT';
           writeln('The updated species definitions will be stored in ',newname);
           assign(newfile,newname);
           rewrite(newfile); {write the species changes to the newfile}
            BEGIN for i := 1 to nspecies do
              BEGIN for j := 1 to maxchar do
               write(newfile,species[i,j]);
               writeln(newfile);
              END;
            END;
           close(newfile);
         END
          else
           writeln('Changes will not be permanently saved');
         END
         else
          if filestatus = 1 then BEGIN
           rewrite(initfile);
            BEGIN for i := 1 to nspecies do
             BEGIN for j := 1 to maxchar do
              write(initfile,species[i,j]);
              writeln(initfile);
             END;
            END;
          END;
         END
       END; {change character routine}
 END;

PROCEDURE definespecies(var settag: tagdef);
   {assign species characteristics to each species and save to file}
 BEGIN {definespecies}
   filestatus := 0;
     getname(filestatus);
   BEGIN
    if filestatus = 0 then
     BEGIN {read in the species definitions from a pre-existing file}
      reset(initfile);
       BEGIN for i := 1 to nspecies do
        BEGIN for j := 1 to maxchar do
         read(initfile,species[i,j]);
         readln(initfile);
        END;
       END; {done reading in definitions from pre-existing file}
      close(initfile);
      specdefcheck; {call species definition checker}
      exit {back to main};
     END {pre-existing file routine}
    else
     if filestatus = 1 then BEGIN {open a new definition file}
      rewrite(initfile);
     BEGIN {getting new species definitions}
      for i := 1 to nspecies do
       BEGIN
         writeln('Definitions for species ',i);
         REPEAT
         write('Annual or Perennial: ');
         readln(temp);
         UNTIL upcase(temp) IN ['A','P'];
         species[i,1] := upcase(temp) + ' ';
          if species[i,1] = 'A ' then
          BEGIN {set tags not used for annuals to blanks or zeros}
             species[i,2] := '  ';
             species[i,3] := '  ';
             species[i,4] := '  ';
             species[i,6] := '00';
             species[i,7] := '00';
          END {setting tags not used for annuals}
           else BEGIN {set tags used for perennials only}
             REPEAT
             write('Rhizomatous, Bulbous, or Tuberous: ');
             readln(temp);
             UNTIL upcase(temp) IN ['R','B','T'];
             species[i,2] := upcase(temp) + ' ';
             REPEAT
             write('Guerrilla or Phalanx morphology: ');
             readln(temp);
             UNTIL upcase(temp) IN ['G','P'];
             species[i,3] := upcase(temp) + ' ';
             REPEAT
             write('Fast of Slow growing: ');
             readln(temp);
             UNTIL upcase(temp) IN ['F','S'];
             species[i,4] := upcase(temp) + ' ';
             REPEAT
             writeln('Mean duration of connection persistence in months');
             write('[1 =< mean duration =< 36]: ');
             readln(species[i,6]);
              val(species[i,6],tempval,retcode);
             UNTIL tempval IN [1..36];
              if tempval < 10 then
               species[i,6] := '0' + species[i,6];
             REPEAT
             writeln('S.D. of duration of connnection persistence in months');
             write('[0 =< S.D. =< 36]: ');
             readln(species[i,7]);
              val(species[i,7],tempval,retcode);
             UNTIL tempval IN [0..36];
              if tempval < 10 then
               species[i,7] := '0' + species[i,7];
          END; {setting tags for perennials only}
           {tags for all species, whether annuals or perennials}
           IF species[i,1] = 'A' THEN BEGIN
           REPEAT
           write('Spring, (E)Summer, Fall, or Winter growth: ');
           readln(temp);
           UNTIL upcase(temp) IN ['S','E','F','W'];
           species[i,5] := upcase(temp) + ' ';
           END
           ELSE BEGIN
           REPEAT
           write('Spring, (E)Summer, Fall, Winter, or Continuous growth: ');
           readln(temp);
           UNTIL upcase(temp) IN ['S','E','F','W','C'];
           species[i,5] := upcase(temp) + ' ';
           END;
           REPEAT
           write('seeds dispersed Far or Nearby parent; ');
           readln(temp);
           UNTIL upcase(temp) IN ['F','N'];
           species[i,8] := upcase(temp) + ' ';
           REPEAT
           write('Maximum number of years in seed bank [1, 2, or 3]: ');
           readln(temp);
           val(temp,tempval,retcode);
           UNTIL tempval in [1..3];
            species[i,9] := '0' + temp;
           REPEAT
           writeln('Condition required for germination;');
           write('Underwater, Drawdown, or Both: ');
           readln(temp);
           UNTIL upcase(temp) IN ['U','D','B'];
           species[i,10] := upcase(temp) + ' ';
           REPEAT
           write('Competition permitted between species (y/n): ');
           readln(temp);
           UNTIL upcase(temp) IN ['Y','N'];
           species[i,11] := upcase(temp) + ' ';
            if species[i,11] = 'Y ' then
            BEGIN {set tags if competition permitted}
             REPEAT
             write('Competitive ranking [1 =< rank =< ',nspecies,']: ');
             readln(species[i,12]);
              val(species[i,12],tempval,retcode);
             UNTIL tempval IN [1..nspecies];
              if tempval < 10 then
               species[i,12] := '0' + species[i,12];
             REPEAT
             write('Competitive networks permitted (y/n): ');
             readln(temp);
             UNTIL upcase(temp) IN ['Y','N'];
             species[i,13] := upcase(temp) + ' ';
             END {setting tags where competition permitted}
            else {if competition not permitted}
             species[i,12] := '00';
             species[i,13] := 'N ';
       END; {character definition routine for species[i]}
     END; {character definition routine}
       BEGIN {write new definitions to a permanent file with name initfile}
        for i := 1 to nspecies do
         BEGIN for j := 1 to maxchar do
         write(initfile,species[i,j]);
         writeln(initfile);
         END;
       END;
  close(initfile);
  specdefcheck; {call species definition checker}
  exit; {back to main}
   END; {writing out definitions}
   END;
END; {definespecies procedure}

PROCEDURE youset; {user determines starting conditions}
   LABEL SpID;
    BEGIN {youset}
    settag := 'user';
    writeln;
    writeln;
    writeln ('Here, you will define the attributes of up to 10 species');
    writeln ('that will be used in the model');
  SpID: write ('How many species would you like to use (=<',maxsp,')? ');
    readln (nspecies);
     if (nspecies > maxsp) or (nspecies <= 0) then
      BEGIN
       writeln;
       writeln ('Permitted number of species is 0<nspecies<=',maxsp);
        goto SpID
      END;
     definespecies(settag);
    END;

PROCEDURE iset; {computer determines starting conditions}
    BEGIN {iset}
     settag := 'nouser';
     nspecies :=10;
     filename :='COMPUTER.DAT';
     writeln;
     assign(initfile,filename);
     reset(initfile);
     BEGIN for i := 1 to nspecies do
      BEGIN for j := 1 to maxchar do
       read(initfile,species[i,j]);
       readln(initfile);
      END;
     END;
     close(initfile);
     writeln('The computer will set the species definitions to be:');
     showspecies;
     writeln('Computer-determined species definitions are not alterable.');
     writeln('If you would like to define the species characteristics,');
     writeln('exit the program and begin again.');
     REPEAT
      writeln('====>Enter EXIT to leave the program');
      write('====>Enter CONTINUE to continue with computer setup: ');
      readln(compugo);
      compugo := upcase(compugo);
     UNTIL upcase(compugo) IN ['C','E'];
     if (compugo = 'C') then exit {back to main};
     if (compugo = 'E') then exitprog {out of the program};
    END;

PROCEDURE wetset; {setup the wetland}
  BEGIN {wetset}
    BEGIN
     writeln;
     writeln ('Do you want to determine the starting conditions?');
     REPEAT
     writeln ('(Enter Y if you want to do the setup)');
     write ('(Enter N if you want the computer to setup the wetland): ');
     readln (yesno);
     yesno := upcase(yesno);
     UNTIL upcase(yesno) IN ['Y','N'];
    END;

     if yesno='Y' then
       youset {have the user set up the FIELD using procedure YOUSET}
     else if yesno='N' then
       iset; {computer randomly sets up the FIELD using procedure ISET}
  END;
